/**
 * Provides an easy way to index into an array to find the right mask for a given bit length.
 *
 * It basically just provides a mask which will only give the farthest left bits.
 */
export const MOST_SIGNIFICANT_MASK_LIST = [
  0x00000000,
  0x80000000,
  0xc0000000,
  0xe0000000,
  0xf0000000,
  0xf8000000,
  0xfc000000,
  0xfe000000,
  0xff000000,
  0xff800000,
  0xffc00000,
  0xffe00000,
  0xfff00000,
  0xfff80000,
  0xfffc0000,
  0xfffe0000,
  0xffff0000,
  0xffff8000,
  0xffffc000,
  0xffffe000,
  0xfffff000,
  0xfffff800,
  0xfffffc00,
  0xfffffe00,
  0xffffff00,
  0xffffff80,
  0xffffffc0,
  0xffffffe0,
  0xfffffff0,
  0xfffffff8,
  0xfffffffc,
  0xfffffffe,
  0xffffffff,
];

/**
 * Provides an easy way to index into an arary to find the right mask for a given remaining bit length.
 *
 * It basically just provides a mask which will only give the farthest right bits.
 */
export const LEAST_SIGNIFICANT_MASK_LIST = [
  0x00,
  0x00000001,
  0x00000003,
  0x00000007,
  0x0000000f,
  0x0000001f,
  0x0000003f,
  0x0000007f,
  0x000000ff,
  0x000001ff,
  0x000003ff,
  0x000007ff,
  0x00000fff,
  0x00001fff,
  0x00003fff,
  0x00007fff,
  0x0000ffff,
  0x0001ffff,
  0x0003ffff,
  0x0007ffff,
  0x000fffff,
  0x001fffff,
  0x003fffff,
  0x007fffff,
  0x00ffffff,
  0x01ffffff,
  0x03ffffff,
  0x07ffffff,
  0x0fffffff,
  0x1fffffff,
  0x3fffffff,
  0x7fffffff,
  0xffffffff,
];
